angular.module('qaidi.services', [])





// PUSH NOTIFICATIONS
.service('PushNotificationsService', function ($rootScope,$ionicPopup,$translate, $cordovaPush,$location, NodePushServer, GCM_SENDER_ID,Device_id_Storage){
	/* Apple recommends you register your application for push notifications on the device every time it’s run since tokens can change. The documentation says: ‘By requesting the device token and passing it to the provider every time your application launches, you help to ensure that the provider has the current token for the device. If a user restores a backup to a device other than the one that the backup was created for (for example, the user migrates data to a new device), he or she must launch the application at least once for it to receive notifications again. If the user restores backup data to a new device or reinstalls the operating system, the device token changes. Moreover, never cache a device token and give that to your provider; always get the token from the system whenever you need it.’ */
	
	  return {
	register:function() {
		var config = {};

		// ANDROID PUSH NOTIFICATIONS
		if(ionic.Platform.isAndroid())
		{
			config = {
				"senderID": GCM_SENDER_ID
				};

			$cordovaPush.register(config).then(function(result) {
				
			}, function(err) {
				// Error
				console.log("$cordovaPush.register Error");
				console.log(err);
			});

			$rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
			//	console.log(JSON.stringify([notification]));

				switch(notification.event)
				{
					case 'registered':
						if (notification.regid.length > 0 ) {
							NodePushServer.storeDeviceToken("android", notification.regid);
						}
						break;

					case 'message':
					payload = notification.payload;
					
					// if this flag is set, this notification happened while we were in the foreground.
					// you might want to play a sound to get the user's attention, throw up a dialog, etc.
					
					if (notification.foreground) {
					console.log("Notifiction Received: "+payload.message);
                    $ionicPopup.confirm({
                        title: payload.title,
                        content: payload.message,
						cancelText: $translate.instant('MrQaidi.close'),
						okText: $translate.instant('MrQaidi.open')
                    })
                    .then(function(result) {
                        if(result) {
                            $location.path("/app/post/"+payload.postid);
                        }
                    });
					//   $("#app-status-ul").append('<li>--INLINE NOTIFICATION--' + '</li>');
						// if the notification contains a soundname, play it.
						//var my_media = new Media("/android_asset/www/" + notification.soundname);
						//my_media.play();
						//$location.path("/app/post/"+payload.postid);

					} else { // otherwise we were launched because the user touched a notification in the notification tray.
					if (notification.coldstart) {
					$location.path("/app/post/"+payload.postid);

					} else {
                	$location.path("/app/post/"+payload.postid);

					}
				}	
						
						break;

					case 'error':
						console.log('GCM error = ' + notification.msg);
						break;

					default:
						console.log('An unknown GCM event has occurred');
						break;
				}
			});

			// WARNING: dangerous to unregister (results in loss of tokenID)
			// $cordovaPush.unregister(options).then(function(result) {
			//   // Success!
			// }, function(err) {
			//   // Error
			// });
		}

		if(ionic.Platform.isIOS())
		{
			config = {
				"badge": true,
				"sound": true,
				"alert": true
			};

			$cordovaPush.register(config).then(function(result) {
				// Success -- send deviceToken to server, and store for future use
				console.log("result: " + result);
				NodePushServer.storeDeviceToken("ios", result);
			}, function(err) {
				console.log("Registration error: " + err);
			});

			$rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
									iospayload = notification;
									console.log(iospayload.postid);
                    $ionicPopup.confirm({
                        title: iospayload.alert,
                        content: "",
						cancelText: $translate.instant('MrQaidi.close'),
						okText: $translate.instant('MrQaidi.open')
                    })
                    .then(function(result) {
                        if(result) {
                            $location.path("/app/post/"+iospayload.postid);
                        }
                    });
				console.log(notification.alert, "::Push Notification Received");
			});
		}
	},
	     unregister: function(lang_url) {
			config = {
				"senderID": GCM_SENDER_ID
				};
			// WARNING: dangerous to unregister (results in loss of tokenID)
			 $cordovaPush.unregister(config).then(function(result) {
				var LocalDeviceID =Device_id_Storage.get();	
				NodePushServer.removeDeviceToken(LocalDeviceID,lang_url);

			//   // Success!
			 }, function(err) {
			//   // Error
			 });
		}
	
 };
 
})

// Service definition
.factory('Language', function ($translate) {
    //add the languages you support here. ar stands for arabic
    var rtlLanguages = ['ar'];

    var isRtl = function() {
        var languageKey = $translate.proposedLanguage() || $translate.use();
		
		if(languageKey){
			
			        for (var i=0; i<rtlLanguages.length; i+=1) {
            if (languageKey.indexOf(rtlLanguages[i])>-1) 
                return true;
        }
        return false; 
		}

    };

    //public api
    return {
        isRtl: isRtl
    };
})

;
